> For the complete documentation index, see [llms.txt](https://docs.caf.io/llms.txt). Markdown versions of documentation pages are available by appending `.md` to page URLs; this page is available as [Markdown](https://docs.caf.io/caf-sdk/ios/standalone-modules/caffaceauth/builder.md).

# Building the SDK

## Creating a FaceAuthSDK instance

To create a `FaceAuthSDK` instance, use the `Builder` class. This class provides a set of methods to configure the SDK instance.

### Builder Properties

| Property                 | Type       | Description                                                                 | Required |
| ------------------------ | ---------- | --------------------------------------------------------------------------- | :------: |
| `stage`                  | `CAFStage` | Defines the environment stage (e.g., `.prod`, `.beta`). Default is `.prod`. |     ❌    |
| `sessionId`              | `String`   | Session ID for the current authentication process.                          |     ✅    |
| `withLoading`            | `Bool`     | Indicates whether to show a loading screen. Default is `false`.             |     ❌    |
| `token`                  | `String`   | Authentication token required for the SDK.                                  |     ✅    |
| `filter`                 | `Filter`   | Defines the filter for liveness detection. Default is `.lineDrawing`.       |     ❌    |
| `personId`               | `String`   | Identifier for the person being authenticated. Default is an empty string.  |     ❌    |
| `imageUrlExpirationTime` | `Time`     | Expiration time for image URLs. Default is `.thirtyMin`.                    |     ❌    |

### Builder Methods

| Method                                   | Type       | Description                                                          | Required |
| ---------------------------------------- | ---------- | -------------------------------------------------------------------- | :------: |
| `setStage(stage:)`                       | `CAFStage` | Sets the environment stage for the SDK. Default is `.prod`.          |     ❌    |
| `setSessionId(sessionId:)`               | `String`   | Sets the session ID for the authentication process.                  |     ✅    |
| `setLoading(withLoading:)`               | `Bool`     | Configures whether a loading screen should be shown.                 |     ❌    |
| `setAuthBaseUrl(authBaseUrl:)`           | `String`   | Sets the base URL for authentication.                                |     ✅    |
| `setLivenessBaseUrl(livenessBaseUrl:)`   | `String`   | Sets the base URL for liveness detection.                            |     ✅    |
| `setFilter(filter:)`                     | `Filter`   | Configures the liveness detection filter. Default is `.lineDrawing`. |     ❌    |
| `setCertificates(certificates:)`         | `[String]` | Adds certificates required for secure communication.                 |     ✅    |
| `setImageUrlExpirationTime(time:)`       | `Time`     | Sets the expiration time for image URLs. Default is `.thirtyMin`.    |     ❌    |
| `.setCustomLocalization(named: String?)` | `String?`  | Sets the name of the Localization File for Iproov Strings            |     ❌    |

### Example

```swift
import FaceLiveness

let faceAuthSDK: FaceAuthSDK?

private func setupFaceAuthSDK() {
    faceAuthSDK = FaceAuthSDK.Builder()
        .setStage(stage: .prod)
        .setSessionId(sessionId: "session123")
        .setLoading(withLoading: true)
        .setAuthBaseUrl(authBaseUrl: "https://auth.example.com")
        .setLivenessBaseUrl(livenessBaseUrl: "https://liveness.example.com")
        .setFilter(filter: .lineDrawing)
        .setCertificates(certificates: ["cert1", "cert2"])
        .setImageUrlExpirationTime(time: .thirtyMin)
        .setCustomLocalization(named: "Iproov-strings-file-name")
        .build()
}
```


---

# Agent Instructions
This documentation is published with GitBook. GitBook is the documentation platform designed so that both humans and AI agents can read, navigate, and reason over technical content effectively. Learn more at gitbook.com.

## Querying This Documentation
If you need additional information that is not directly available in this page, you can query the documentation dynamically by asking a question.

Perform an HTTP GET request on the current page URL with the `ask` query parameter, and the optional `goal` query parameter:

```
GET https://docs.caf.io/caf-sdk/ios/standalone-modules/caffaceauth/builder.md?ask=<question>&goal=<endgoal>
```

`ask` is the immediate question: it should be specific, self-contained, and written in natural language.
`goal` is optional and describes the broader end goal you are ultimately trying to accomplish on behalf of the user. GitBook uses it to tailor the answer towards what is most useful for that goal.

The response will contain a direct answer to the question and relevant excerpts and sources from the documentation.

Use this mechanism when the answer is not explicitly present in the current page, you need clarification or additional context, or you want to retrieve related documentation sections.
